
function ruboardMakeGoogleRequestProc(mode) 
{
   var Url;
   var ruboards_forum = document.getElementById("ruboards_forum").selectedItem.value;
   var ruboards_as_q = document.getElementById("ruboards_as_q").value;
   var ruboards_as_oq = document.getElementById("ruboards_as_oq").value;
   var ruboards_as_eq = document.getElementById("ruboards_as_eq").value;
   if(ruboards_as_q || ruboards_as_oq)
   {
      if(mode == 1)
      {
         Url = ("http://www.google.com/search?as_q=" + ruboards_as_q + "&as_oq=" + ruboards_as_oq + 
                     "&as_eq=" + ruboards_as_eq + "&as_epq=" + ruboards_forum + 
                     "&hl=ru&inlang=ru&ie=windows-1251&oe=windows-1251&num=20&lr=&cr=&as_ft=i&as_filetype=&as_qdr=all&as_occt=any&as_dt=i&as_sitesearch=forum.ru-board.com&as_rights=&safe=images");
      }
      else
      {
         Url = ("http://forum.ru-board.com/google.cgi?as_q=" + ruboards_as_q + "&as_oq=" + ruboards_as_oq + 
                  "&as_eq=" + ruboards_as_eq + "&as_epq=" + ruboards_forum + 
                  "&sitesearch=forum.ru-board.com&domains=forum.ru-board.com&client=pub-3191513952494802&forid=1&channel=8862539797&ie=windows-1251&oe=windows-1251&hl=ru&flav=0000&sig=ZVRHj8fTJJksJ4sh&cof=GALT%3A%23008000%3BGL%3A1%3BDIV%3A%23336699%3BVLC%3A663399%3BAH%3Acenter%3BBGC%3AFFFFFF%3BLBGC%3A336699%3BALC%3A0000C0%3BLC%3A0000C0%3BT%3A000000%3BGFNT%3A0000C0%3BGIMP%3A0000C0%3BFORID%3A11");
      }
      return(Url);
   }
}

function ruboardOpenCurrentProc(filter)
{
   var url;
   if (filter == true)
   {
      var ruboards_forum;
      var ruboards_filterby;
      var ruboards_word;
      if(document.getElementById("sidebar").contentWindow.location.href == "chrome://ruboard/content/ruboard_sidebar.xul")
      {
         ruboards_forum = document.getElementById("sidebar").contentWindow.document.getElementById("ruboards_forum").selectedItem.value;
         ruboards_filterby = document.getElementById("sidebar").contentWindow.document.getElementById("ruboards_filterby").selectedItem.value;
         ruboards_word = document.getElementById("sidebar").contentWindow.document.getElementById("ruboards_word").value;
      }
      else
      {
         var PrefSrv = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.ruboard.");
         ruboards_forum = "forum=" + PrefSrv.getCharPref("search_forum").substring(15);
         ruboards_filterby = PrefSrv.getCharPref("search_filterby").substring(18);
         ruboards_word = PrefSrv.getComplexValue("search_word", Components.interfaces.nsISupportsString).data;
      }
      url = ruboardMakeFilterProc(ruboards_forum, ruboards_filterby, ruboards_word);
   }
   else
   {
      url = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getComplexValue("extensions.ruboard.last_opened_url", Components.interfaces.nsISupportsString).data;
   }
   if (url)
   {
      getBrowser().addTab(url);
   }
}

function ruboardOpenSidebarFilterProc(event)
{
   var url;
   var ruboards_forum;
   var ruboards_filterby;
   var ruboards_word;
   ruboards_forum = document.getElementById("ruboards_forum").selectedItem.value;
   ruboards_filterby = document.getElementById("ruboards_filterby").selectedItem.value;
   ruboards_word = document.getElementById("ruboards_word").value;
   url = ruboardMakeFilterProc(ruboards_forum, ruboards_filterby, ruboards_word);
   if (url)
   {
      parent.ruboardForumOpenProc(event, url);
   }
}

function ruboardMakeFilterProc(ruboards_forum, ruboards_filterby, ruboards_word)
{
   if(ruboards_forum && ruboards_filterby && ruboards_word)
   {
      var url = (parent.ruboardForumSelectProc() + "forum.cgi?action=filter&" + ruboards_forum + 
                  "&filterby=" + ruboards_filterby + "&word=" + ruboards_word);
      return(url);
   }
}

function ruboardOnDropProc(event, element) 
{ 
    var value = event.dataTransfer.getData("text/plain");
    element.value = value; 
    event.stopPropagation();
    event.preventDefault();
}

function ruboardForumSelectProc() 
{
	if (document.getElementById("ruboard_alternative_check").hasAttribute("checked")) 
	{
		return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getComplexValue("extensions.ruboard.alternative_link", Components.interfaces.nsISupportsString);
	}
	else 
	{
		return "http://forum.ru-board.com/";
	}
}

function ruboardForumOpenProc(event, url, dontsavelast) 
{
	if(url)
	{
      if (!dontsavelast)
      {
         var word = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
         word.data = url;
         Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).setComplexValue("extensions.ruboard.last_opened_url", Components.interfaces.nsISupportsString, word);
   	}
   	if (event.button == 0)
   	{
   		loadURI(url);
   	} 
   	else 
   	{
   		getBrowser().addTab(url);
   	}
	}
}

function ruboardSetSearchSelectProc()
{
   var PrefSrv = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.ruboard.");
   document.getElementById("ruboards_forum").selectedItem = document.getElementById(PrefSrv.getCharPref("search_forum"));
   document.getElementById("ruboards_filterby").selectedItem = document.getElementById(PrefSrv.getCharPref("search_filterby"));
   document.getElementById("ruboards_word").value = PrefSrv.getComplexValue("search_word", Components.interfaces.nsISupportsString).data;
}

function ruboardSaveSearchSelectProc()
{
   var PrefSrv = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.ruboard.");
   var word = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
   word.data = document.getElementById("ruboards_word").value;
   PrefSrv.setCharPref("search_forum", document.getElementById("ruboards_forum").selectedItem.id);
   PrefSrv.setCharPref("search_filterby", document.getElementById("ruboards_filterby").selectedItem.id);
   PrefSrv.setComplexValue("search_word", Components.interfaces.nsISupportsString, word);
}
